import sys
import os
from csc_util import *
from csc_strings import *
from csc_globals import *

def getUserInput(tasks):
    """Get user input"""
    if sys.platform == 'darwin':
        print strings['macMainMenu']
        input = readChar().upper()
        if input == "E":
            source = getPL()
            dest = chooseFile(strings['getDest'],False)
            if dest != "" and source != "":
                tasks.append( ("extract-mac-profile",source,".pycs_temp") )
                tasks.append( ("convert-profile",".pycs_temp",dest) )
                tasks.append( ("clean-temp-file",".pycs_temp") )
                tasks.append( ("interactive",) )
        elif input == 'S':
            source = chooseFile(strings['getSource'],True)
            dest = getPL()
            if dest != "" and source != "":
                tasks.append( ("convert-profile",source,".pycs_temp") )
                tasks.append( ("store-mac-profile",".pycs_temp",dest) )
                tasks.append( ("clean-temp-file",".pycs_temp") )
                tasks.append( ("interactive",) )
        elif input == 'X':
            tasks.append( ("choose-file",) )
            tasks.append( ("advanced-interactive",) )
    else:
        tasks.append( ("choose-file",) )
        tasks.append( ("advanced-interactive",) )

def interactiveEditMode(tasks):
    global curFile
    print strings['menu']
    input = readChar().upper()
    if input == 'W':
        print strings['addRemove']
        input = readChar().upper()
        if input == strings['addResponse']:
            task = ("add-weapon",)
            print strings['whichWeapon']
            task += (readNum(),)
            print strings['level']
            task += (readNum(),)
            print strings['weaponEnergy']
            task += (readNum(),)
            print strings['ammo']
            task += (readNum(),)
            task += (curFile,)
            tasks.append(task)
        elif input == strings['removeResponse']:
            task = ("remove-weapon",)
            print strings['whichWeapon']
            task += (readNum(),)
            task += (curFile,)
            tasks.append(task)
        else:
            print strings['wrong']
            tasks.append( ("advanced-interactive",) )
            return
    elif input == 'O':
        tasks.append( ("choose-file",) )
        tasks.append( ("advanced-interactive",) )
    elif input == 'I':
        print strings['addRemove']
        input = readChar().upper()
        if input == 'A':
            task = ("add-item",)
            print strings['whichItem']
            task += (readNum(),)
            print strings['equip?']
            input = readChar().upper()
            if input == 'Y':
                task += (True,)
            elif input == 'N':
                task += (False,)
            else:
                print strings['wrong']
                tasks.append( ("advanced-interactive",) )
                return
            task += (curFile,)
            tasks.append(task)
        elif input == 'R':
            task = ("remove-item")
            print strings['whichItem']
            task += (readNum(),)
            task += (curFile,)
            tasks.append(task)
        else:
            print strings['wrong']
            tasks.append( ("advanced-interactive",) )
            return
    elif input == 'X':
        tasks.append( ("advanced-interactive",) )
    elif input == 'T':
        tasks.append( ("advanced-interactive",) )
    elif input == 'F':
        tasks.append( ("advanced-interactive",) )
    elif input == 'Q':
        if sys.platform == "darwin": tasks.append( ("interactive",) )

def chooseFile(prompt,mustExist):
    file = ""
    while True:
        print prompt
        input = readLine()
        if input.upper() == 'Q':
            break
        elif mustExist and not os.path.exists(input):
            print strings['notFound'] % input
            continue
        else:
            file = input
            break
    return file

def getPL():
    file = ""
    if sys.platform == "darwin":
        if not os.path.exists(defPLPath):
            print strings['noPrefs']
        else:
            file = defPLPath
    else:
        print strings['notMac']
    return file

def chooseMainFile():
    global curFile
    curFile = chooseFile(strings['editWhich'],True)